Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.bea.jvm
Interface CallTraceElement

public interface CallTraceElement

1.3 compatible version of StackTraceElement. Want this functionality in the API no matter the JDK level.

Author:
  Marcus Hirt

Method Summary
`boolean` | `equals(java.lang.Object obj)` Returns true if the specified object is another `CallTraceElement` instance representing the same execution point as this instance.
`java.lang.String` | `getClassName()` Returns the fully qualified name of the class containing the execution point represented by this call trace element.
`java.lang.String` | `getFileName()` Returns the name of the source file containing the execution point represented by this stack trace element.
`int` | `getLineNumber()` Returns the line number of the source line containing the execution point represented by this call trace element.
`java.lang.String` | `getMethodName()` Returns the name of the method containing the execution point represented by this call trace element.
`ThreadSnapshot.Monitor[]` | `getMonitors()` Return the monitors that was taken by the thread at this stack trace element.
`boolean` | `isNativeMethod()` Returns true if the method containing the execution point represented by this call trace element is a native method.
`java.lang.String` | `toString()` Returns a string representation of this CallTraceElement.

Method Detail

### getFileName

    public java.lang.String getFileName()

  Returns the name of the source file containing the execution point represented by this stack trace element. Generally, this corresponds to the `SourceFile` attribute of the relevant `class` file (as per The Java Virtual Machine Specification, Section 4.7.7). In some systems, the name may refer to some source code unit other than a file, such as an entry in source repository.

  Returns:
    the name of the file containing the execution point represented by this stack trace element, or `null` if this information is unavailable.

### getLineNumber

    public int getLineNumber()

  Returns the line number of the source line containing the execution point represented by this call trace element. Generally, this is derived from the `LineNumberTable` attribute of the relevant `class` file (as per The Java Virtual Machine Specification, Section 4.7.8).

  Returns:
    the line number of the source line containing the execution point represented by this call trace element, or a negative number if this information is unavailable.

### getClassName

    public java.lang.String getClassName()

  Returns the fully qualified name of the class containing the execution point represented by this call trace element.

  Returns:
    the fully qualified name of the `Class` containing the execution point represented by this call trace element.

### getMethodName

    public java.lang.String getMethodName()

  Returns the name of the method containing the execution point represented by this call trace element. If the execution point is contained in an instance or class initializer, this method will return the appropriate special method name, `<init>` or `<clinit>`, as per Section 3.9 of The Java Virtual Machine Specification.

  Returns:
    the name of the method containing the execution point represented by this call trace element.

### isNativeMethod

    public boolean isNativeMethod()

  Returns true if the method containing the execution point represented by this call trace element is a native method.

  Returns:
    `true` if the method containing the execution point represented by this call trace element is a native method.

### toString

    public java.lang.String toString()

  Returns a string representation of this CallTraceElement. The format of this string depends on the implementation, but the following examples may be regarded as typical:
  - `"MyClass.mash(MyClass.java:9)"` - Here, `"MyClass"` is the fully-qualified name of the class containing the execution point represented by this call trace element, `"mash"` is the name of the method containing the execution point, `"MyClass.java"` is the source file containing the execution point, and `"9"` is the line number of the source line containing the execution point.
  - `"MyClass.mash(MyClass.java)"` - As above, but the line number is unavailable.
  - `"MyClass.mash(Unknown Source)"` - As above, but neither the file name nor the line number are available.
  - `"MyClass.mash(Native Method)"` - As above, but neither the file name nor the line number are available, and the method containing the execution point is known to be a native method.

  Overrides:
    `toString` in class `java.lang.Object`
  See Also:
    `Throwable.printStackTrace()`

### equals

    public boolean equals(java.lang.Object obj)

  Returns true if the specified object is another `CallTraceElement` instance representing the same execution point as this instance. Two call trace elements `a` and `b` are equal if and only if:

           equals(a.getFileName(), b.getFileName()) &&
           a.getLineNumber() == b.getLineNumber()) &&
           equals(a.getClassName(), b.getClassName()) &&
           equals(a.getMethodName(), b.getMethodName())

  where `equals` is defined as:

           static boolean equals(Object a, Object b) {
               return a==b || (a != null && a.equals(b));
           }

  Overrides:
    `equals` in class `java.lang.Object`
  Parameters:
    `obj` - the object to be compared with this call trace element.
  Returns:
    true if the specified object is another `CallTraceElement` instance representing the same execution point as this instance.

### getMonitors

    public ThreadSnapshot.Monitor[] getMonitors()

  Return the monitors that was taken by the thread at this stack trace element. With one exceptions, all these monitors are currently held by the thread. The one exception is if the thread is waiting for notification on a monitor. Even though this monitor was taken in some stack trace element, it is currently released by the thread. To be sure that the thread still holds the monitors returned by this function, you must check each of them against the "waitingOn" monitor of the thread, if any. Note the following about this method:
  - The returned list is not ordered. The monitors might have been taken in any order in this stack frame.
  - Due to optimizations in the JVM, the monitors returned might in some cases actually have been taken in another call trace element than this.
  - If this call trace element contains no monitors, this method returns an empty list.

  Returns:
    an array of monitors taken by the thread at this stack frame.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD